﻿/**
* Test Circle 3
* @author nutsu
* @version 0.1
*/

package  {

	import flash.display.Sprite;
	import flash.display.Shape;
	import flash.events.Event;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	
	public class TestCircle3 extends Sprite{
		
		//円
		private var c0:Circle;
		private var c1:Circle;
		
		//移動PRM
		private var v0:Point;
		private var v1:Point;
		private var rect0:Rectangle;
		private var rect1:Rectangle;
		
		public function TestCircle3(){
			super();
			
			c0 = new Circle( 70 , 130, stage.stageHeight*0.5 );
			c1 = new Circle( 100 , 260, stage.stageHeight*0.5 );
			
			v0 = getRandomVector( 3 );
			v1 = getRandomVector( 3 );
			
			rect0 = new Rectangle( c0.r, c0.r, stage.stageWidth-2*c0.r, stage.stageHeight-2*c0.r );
			rect1 = new Rectangle( c1.r, c1.r, stage.stageWidth-2*c1.r, stage.stageHeight-2*c1.r );
			
			//onenterframe
			addEventListener( Event.ENTER_FRAME, onEnterFrame );
		}
		
		private function onEnterFrame( e:Event ):void{
			setNextPoint( c0, v0, rect0 );
			setNextPoint( c1, v1, rect1 );
			draw();
		}
		
		private function draw():void{
			graphics.clear();
			graphics.lineStyle( 10, 0xffffff, 1.0, false, "normal", null, "miter"  );
			
			//交差チェック
			var dv:Point = new Point( c1.x-c0.x, c1.y-c0.y );
			var len:Number = dv.length;
			
			if( len<Math.abs(c1.r-c0.r) ){
				//内包
				if( c1.r>c0.r ){
					c1.draw( graphics );
				}else{
					c0.draw( graphics );
				}
			}else if( len<( c1.r+c0.r ) ){
				//ベクトル上のｘ
				var t:Number = 0.5*( len*len + c0.r*c0.r - c1.r*c1.r )/len;
				//ベクトルからのラジアン
				var a0:Number = Math.acos( t/c0.r );
				var a1:Number = Math.acos( (len-t)/c1.r );
				//中心ベクトルのラジアン
				var a:Number = Math.atan2( dv.y, dv.x );
				
				//描画
				var arcRad0:Number = (Math.PI-a0)*2;
				var arcRad1:Number = (Math.PI-a1)*2;
				
				var delta_a:Number;
				var ctrl_r:Number;
				var i:int;
				var next_a:Number;
				var ctrl_a:Number;
				var sa:Number;
				var sx:Number;
				var sy:Number;
				
				//
				sa = a + a0;
				delta_a = arcRad0/8;
				ctrl_r = c0.r/Math.cos(delta_a*0.5);
				sx = c0.x + c0.r*Math.cos(sa);
				sy = c0.y + c0.r*Math.sin(sa);
				graphics.moveTo( sx, sy );
				for( i=1 ; i<=8 ; i++ ){
					next_a = sa + delta_a*i;
					ctrl_a = next_a - delta_a*0.5;
					graphics.curveTo( c0.x + ctrl_r*Math.cos(ctrl_a), c0.y + ctrl_r*Math.sin(ctrl_a),
										c0.x + c0.r*Math.cos(next_a), c0.y + c0.r*Math.sin(next_a) );
				}
				//
				sa = a + a1 + Math.PI;
				delta_a = arcRad1/8;
				ctrl_r = c1.r/Math.cos(delta_a*0.5);
				graphics.curveTo( c0.x + c0.r*Math.cos(a-a0), c0.y + c0.r*Math.sin(a-a0),
									c1.x + c1.r*Math.cos(sa), c1.y + c1.r*Math.sin(sa) );
				for( i=1 ; i<=8 ; i++ ){
					next_a = sa + delta_a*i;
					ctrl_a = next_a - delta_a*0.5;
					graphics.curveTo( c1.x + ctrl_r*Math.cos(ctrl_a), c1.y + ctrl_r*Math.sin(ctrl_a),
										c1.x + c1.r*Math.cos(next_a), c1.y + c1.r*Math.sin(next_a) );
				}
				graphics.curveTo( c0.x + c0.r*Math.cos(a+a0), c0.y + c0.r*Math.sin(a+a0), sx, sy );
			}else{
				c0.draw( graphics );
				c1.draw( graphics );
			}
			
			
		}
		
		private function setNextPoint( c:Circle, v:Point, rect:Rectangle ):void{
			c.x += v.x;
			c.y += v.y;
			if( !rect.contains( c.x, c.y ) ){
				if( c.x<rect.left ){
					v.x *= -1;
					c.x = 2*rect.left - c.x;
				}else if( c.x>rect.right ){
					v.x *= -1;
					c.x = 2*rect.right - c.x;
				}
				if( c.y<rect.top ){
					v.y *= -1;
					c.y = 2*rect.top - c.y;
				}else if( c.y>rect.bottom ){
					v.y *= -1;
					c.y = 2*rect.bottom - c.y;
				}
			}
		}
		
		private function getRandomVector(len:Number):Point{
			var v:Point = new Point( 0.5-Math.random(), 0.5-Math.random() );
			v.normalize(len);
			return v;
		}
	}
	
}
